const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ReviewsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.create(
            {
                id: data.id || undefined,
        
        rating: data.rating
        ||
        null
            ,
            
        text: data.text
        ||
        null
            ,
            
        is_verified_job: data.is_verified_job
        ||
        false
        
            ,
            
        status: data.status
        ||
        null
            ,
            
        moderation_notes: data.moderation_notes
        ||
        null
            ,

        response: data.response || null,
        response_at_ts: data.response ? new Date() : null,
            
        created_at_ts: data.created_at_ts
        ||
        null
            ,
            
        updated_at_ts: data.updated_at_ts
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await reviews.setBusiness( data.business || null, {
            transaction,
        });
        
        await reviews.setUser( data.user || null, {
            transaction,
        });
        
        await reviews.setLead( data.lead || null, {
            transaction,
        });
        

        

        

        return reviews;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const reviewsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                rating: item.rating
            ||
            null
            ,
            
                text: item.text
            ||
            null
            ,
            
                is_verified_job: item.is_verified_job
            ||
            false
        
            ,
            
                status: item.status
            ||
            null
            ,
            
                moderation_notes: item.moderation_notes
            ||
            null
            ,
            
                created_at_ts: item.created_at_ts
            ||
            null
            ,
            
                updated_at_ts: item.updated_at_ts
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const reviews = await db.reviews.bulkCreate(reviewsData, { transaction });

        // For each item created, replace relation files
        

        return reviews;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const reviews = await db.reviews.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.rating !== undefined) updatePayload.rating = data.rating;
        
        
        if (data.text !== undefined) updatePayload.text = data.text;
        
        
        if (data.is_verified_job !== undefined) updatePayload.is_verified_job = data.is_verified_job;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.moderation_notes !== undefined) updatePayload.moderation_notes = data.moderation_notes;

        if (data.response !== undefined) {
          updatePayload.response = data.response;
          updatePayload.response_at_ts = new Date();
        }
        
        
        if (data.created_at_ts !== undefined) updatePayload.created_at_ts = data.created_at_ts;
        
        
        if (data.updated_at_ts !== undefined) updatePayload.updated_at_ts = data.updated_at_ts;
        
        
        updatePayload.updatedById = currentUser.id;

        await reviews.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await reviews.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await reviews.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.lead !== undefined) {
            await reviews.setLead(
              
              data.lead,
              
              { transaction }
            );
        }
        

        
        

        

        return reviews;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of reviews) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of reviews) {
                await record.destroy({transaction});
            }
        });


        return reviews;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findByPk(id, options);

        await reviews.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await reviews.destroy({
            transaction
        });

        return reviews;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findOne(
            { where },
            { transaction },
        );

        if (!reviews) {
            return reviews;
        }

        const output = reviews.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await reviews.getBusiness({
            transaction
        });
        
        
        output.user = await reviews.getUser({
            transaction
        });
        
        
        output.lead = await reviews.getLead({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    const currentUser = options?.currentUser;

    // Data Isolation
    if (currentUser && currentUser.app_role) {
        const roleName = currentUser.app_role.name;
        if (roleName === 'Verified Business Owner') {
            if (currentUser.businessId) {
                where.businessId = currentUser.businessId;
            } else {
                where['$business.owner_userId$'] = currentUser.id;
            }
        } else if (roleName === 'Consumer') {
            where.userId = currentUser.id;
        }
    }

    let include = [

      {
        model: db.businesses,
        as: 'business',
        required: false,
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : undefined,
        
      },

      {
        model: db.users,
        as: 'user',
        required: false,
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : undefined,
        
      },

      {
        model: db.leads,
        as: 'lead',
        required: false,
        where: filter.lead ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lead.split('|').map(term => Utils.uuid(term)) } },
            {
              keyword: {
                [Op.or]: filter.lead.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : undefined,
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reviews',
                        'text',
                        filter.text,
                    ),
                };
            }
            
            if (filter.moderation_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reviews',
                        'moderation_notes',
                        filter.moderation_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.ratingRange) {
                const [start, end] = filter.ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.created_at_tsRange) {
                const [start, end] = filter.created_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.updated_at_tsRange) {
                const [start, end] = filter.updated_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    updated_at_ts: {
                    ...where.updated_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    updated_at_ts: {
                    ...where.updated_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_verified_job) {
                where = {
                    ...where,
                is_verified_job: filter.is_verified_job,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            subQuery: false,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.reviews.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'reviews',
                        'text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.reviews.findAll({
            attributes: [ 'id', 'text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.text,
        }));
    }

    
};
